#property indicator_separate_window
#property indicator_buffers 1
#property indicator_minimum 0
#property indicator_color1 Green

extern int Pips = 50;
extern int PeriodData = PERIOD_M1;

int Pos, PosData;
double Results[];
 
void init()
{
  PosData = iBarShift(Symbol(), PeriodData, Time[Bars - 1]);
  Pos = iBarShift(Symbol(), Period(), iTime(Symbol(), PeriodData, PosData));
  
  SetIndexBuffer(0, Results);
  SetIndexStyle(0, DRAW_HISTOGRAM);
  
  return;
}

int GetZigZag( int Pips )
{
  static int Min, Max = 0;
  static bool FlagUP = TRUE;
  
  int PriceLow, PriceHigh;
    
  while (PosData > 0)
  {
    PriceLow = iLow(Symbol(), PeriodData, PosData) / Point + 0.1;
    PriceHigh = iHigh(Symbol(), PeriodData, PosData) / Point + 0.1;
    
    if (FlagUP)
    {
      if (PriceHigh > Max)
        Max = PriceHigh;
      else if (Max - PriceLow >= Pips)
      {
        FlagUP = FALSE;
        Min = PriceLow;
        
        return(1);
      }
    }
    else // (FlagUP == FALSE)
    {
      if (PriceLow < Min)
        Min = PriceLow;
      else if (PriceHigh - Min >= Pips)
      {
        FlagUP = TRUE;
        Max = PriceHigh;

        return(1);
      }    
    }
    
    PosData--;
  }
  
  return(0);
}

void start()
{
  static bool FirstRun = TRUE;
  
  if (!FirstRun)
    return;
    
  FirstRun = FALSE;

  Results[Pos] = 0;
 
  while (PosData >= 0)
  {
    Results[Pos] += GetZigZag(Pips);
    
    if (Time[Pos - 1] < iTime(Symbol(), PeriodData, PosData))
    {
      Pos--;
      Results[Pos] = 0;
    }
      
    PosData--;
  }
  
  return;
}